// src/backend/sgpemv2/process_statistics.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef PROCESS_STATISTICS_HH
#define PROCESS_STATISTICS_HH 1

#include "thread_statistics.hh"

#include <sgpemv2/sgpemv2-visibility.hh>
#include <sgpemv2/schedulable_statistics.hh>
#include <sgpemv2/thread_statistics.hh>
#include <sgpemv2/process.hh>

#include <glibmm/ustring.h>

#include <vector>

namespace sgpem
{
  class ProcessStatistics : public SchedulableStatistics
  {
    public:
      ~ProcessStatistics();

      virtual float             get_average_response_time() const = 0;
      virtual const Process*	get_core() const = 0;

      virtual std::vector<const ThreadStatistics*> get_threads_statistics() const = 0;

    protected:
      ProcessStatistics();
  };
}

#endif
