// src/statistics_container_window.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef STATISTICS_CONTAINER_WINDOW_HH
#define STATISTICS_CONTAINER_WINDOW_HH 1

#include "schedulables_statistics_widget.hh"
#include "simulation_statistics_widget.hh"


#include "gettext.h"

#include <sgpemv2/simulation.hh>

#include <gtkmm/window.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/scrollbar.h>
#include <libglademm/xml.h>

#include <cassert>
#include <iostream>

namespace sgpem 
{
  /**
   * \brief Window which displays schedulable-specific and simulation statistics
   */
  class StatisticsContainerWindow
  {
    public:
      explicit StatisticsContainerWindow(const std::string& gladefile = GLADEDIR "/statistics-window.glade");
      virtual ~StatisticsContainerWindow();

      void                                      make_child(Gtk::Window&);
      TabularSchedulableStatisticsWidget*   	get_tabular_schedulables_statistics_widget();
      TabularSimulationStatisticsWidget*   	get_tabular_simulation_statistics_widget();
      Gtk::Window*                              get_main_window();
    protected:

      Glib::RefPtr<Gnome::Glade::Xml>           _refXml;
      Gtk::Window*                              _main_win;
      TabularSchedulableStatisticsWidget*       _tab_sched;
      TabularSimulationStatisticsWidget*        _tab_sim;

  };

} // ~ namespace sgpem

#endif

